#include <iostream>
#include <vector>
#include <math.h>
using namespace std;
const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
int main()
{
    size_t number_count;

    cout << "Enter number count: ";
    cin >> number_count;

    vector<double> numbers(number_count);
    numbers.resize(number_count);
    for(size_t i=0;i<number_count;i++)
    {
        cin>>numbers[i];
    }
    size_t bin_count;
    cin>>bin_count;
    vector<size_t> bins(bin_count);
    double Max = numbers[0], Min = numbers[0];
    for (double x : numbers)
    {
        if (x < Min)
        {
            Min = x;
        }
        else if (x > Max)
        {
            Max = x;
        }
    }
    double bin_size = (Max - Min) / bin_count;
    //cout<<" "<<Max<<" "<<Min<<" "<<bin_size<<endl;

    for (size_t i = 0; i < number_count; i++)
        {
            bool found = false;
            for (size_t j = 0; (j < bin_count - 1) && !found; j++)
            {
                auto lo = Min + j * bin_size;
                auto hi = Min + (j + 1) * bin_size;
                if ((lo <= numbers[i]) && (numbers[i] < hi))
                {
                    bins[j]++;
                    found = true;
                }
            }
            if (!found)
            {
                bins[bin_count - 1]++;
            }
        }
    size_t Max_count = bins[0];
    for(size_t x : bins)
    {
        if(x > Max_count)
        {
            Max_count = x;
        }
    }
    for(size_t i =0;i< bin_count;i++)
    {
        size_t height = bins[i];
        printf("%3d:",bins[i]);
        if(Max_count>(MAX_ASTERISK))
        {
            height = (MAX_ASTERISK) * (static_cast<double>(bins[i]) / Max_count);
        }
        for(size_t j=0;j<height; j++)
        {
            cout<<"*";
        }
        cout<<endl;
    }
    return 0;
}
